'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

exports.default = function () {
  return {
    visitor: {
      MemberExpression: function MemberExpression(path) {
        var node = path.node;
        var property = node.property;


        if (property.name === 'isNil' && path.parentPath.type !== 'CallExpression') {
          (function () {
            var name = '';
            var object = (0, _flat2.default)(node);
            Object.keys(object).forEach(function (key) {
              if (/.type$/.test(key)) {
                if (object[key] === 'ThisExpression') {
                  name += 'this.';
                }
              }
              if (/.name$/.test(key)) {
                if (!/arguments/.test(key) && object[key] !== 'isNil') {
                  name += object[key] + '.';
                }
              }
            });
            name = name.replace(/.$/, '');
            var parentObject = (0, _lodash2.default)(path, 'parentPath.node.expression.object');
            var type = (0, _lodash2.default)(parentObject, 'type');
            var args = (0, _lodash2.default)(parentObject, 'arguments');
            if (type === 'CallExpression') {
              name += '(';
              if (args !== undefined) {
                args.forEach(function (arg) {
                  name += arg.name;
                  name += ',';
                });
                name = name.replace(/,$/, '');
              }
              name += ')';
            }
            path.replaceWithSourceString('(' + name + ' === null || ' + name + ' === undefined)');
          })();
        }
      }
    }
  };
};

var _flat = require('flat');

var _flat2 = _interopRequireDefault(_flat);

var _lodash = require('lodash.get');

var _lodash2 = _interopRequireDefault(_lodash);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }